/*
  Visual FoxPro Desktop Events
	activate, deactivate, show , hide, size, zoom, Idle Event

 Vadim Pirozhkoff, 2001
  piva@kurgan.isp.ru
*/
 
#include <Pro_ext.h>

char FAR command[4096];
int Init=0;
int Enabled=0;
int eventid;

char FAR idlecommand[4096];
int IdleInit=0;
int IdleEventId;
int IdleTimeout; // in seconds
unsigned __int64 LastTick;

#define TicksPerSecond  18.2064819336
#define TicksInSecond	1093

void NullTerminate(Value FAR *cVal)
{
	if (!_SetHandSize(cVal->ev_handle, cVal->ev_length + 1)) _Error(182);
	((char FAR *) _HandToPtr(cVal->ev_handle))[cVal->ev_length] = '\0';
}

void EventStatus(ParamBlk  *parm)
// Start/ Stop Desktop handler
{
	if (parm->pCount==1) Enabled=parm->p[0].val.ev_length;
	_RetLogical(Enabled);
}

void EventCommand(ParamBlk  *parm)
// Return command for DeskTop events
{
	if(Init==1) _RetChar(command);
	else _RetChar("");
}

void Event(ParamBlk  *parm)
// Set command for desktop events
{
   NullTerminate(&parm->p[0].val);
   _StrCpy(command, (char *) _HandToPtr(parm->p[0].val.ev_handle));
   command[parm->p[0].val.ev_length+1] = '\0';

   Init=1;
   Enabled=1;
}

FAR EventHandler(WHandle theWindow, EventRec FAR *ev)
// Desktop event handler
{
	if ((Init==0) || (Enabled==0)) return NO;
	if (!(theWindow == _WMainWindow())) return NO;
	
    switch(ev->what)
    {
        case activateEvent:
           break;
        case deactivateEvent:
           break;
        case closeEvent:
           break;
        case hideEvent:
           break;
        case showEvent:
           break;
        case sizeEvent:
           break;
        case zoomEvent:
           break;
	default:
		return NO;
		break;
    }
	_Execute(command);
    return NO;
}

void GetIdleCommand(ParamBlk  *parm)
// Get Idle event command 
{
	if(IdleInit==1) _RetChar(idlecommand);
	else _RetChar("");
}

void GetIdleTimeout(ParamBlk  *parm)
// get Idle timeout 
{
	if(IdleInit==1) _RetInt(IdleTimeout,10);
	else _RetInt(0,10);
}

void FAR IdleEventStatus(ParamBlk  *parm)
// Start/Stop/Get handler state
{
	if (parm->pCount==1) IdleInit=parm->p[0].val.ev_length;
	_RetLogical(IdleInit);
}

void FAR SetIdleEvent(ParamBlk  *parm)
/*	Parameters 
	1. Command to execute 
    2. Time Interval in seconds for foxpro idle event executing */
{
   NullTerminate(&parm->p[0].val);
   _StrCpy(idlecommand, (char *) _HandToPtr(parm->p[0].val.ev_handle));
   idlecommand[parm->p[0].val.ev_length+1] = '\0';
   IdleTimeout=parm->p[1].val.ev_long;

   // If timeout is not set - handler stopped 

   if (IdleTimeout <= 0) IdleInit=0;
   else IdleInit=1;

}

FAR IdleEventHandler(WHandle theWindow, EventRec FAR *ev)
// Idle events handler
{
	if (IdleInit==1) 
	{    
		switch(ev->what)
		{
		case nullEvent: break;
		default:
			LastTick=ev->when;
			return NO;
			break;
		}
		if (((ev->when - LastTick)/TicksInSecond) >= IdleTimeout)
		{
			LastTick=ev->when;
			_Execute(idlecommand);
		}
	}
	return NO;
}

void FAR EventInit() 
{ 
	eventid = _ActivateHandler(EventHandler);
	IdleEventId=_ActivateHandler(IdleEventHandler);
}

void FAR EventDone() 
{ 
	_DeActivateHandler(eventid);
	_DeActivateHandler(IdleEventId);
}

FoxInfo myFoxInfo[] = {
   {"DESKTOP_EVENT",			(FPFI) Event, 1, "C"},
   {"DESKTOP_EVENT_STATUS",		(FPFI) EventStatus, 1, ".L"},
   {"DESKTOP_EVENT_COMMAND",	(FPFI) EventCommand, 0, ""},
   {"IDLE_SET",					(FPFI) SetIdleEvent, 2, "CI"},
   {"IDLE_COMMAND",				(FPFI) GetIdleCommand, 0, ""},
   {"IDLE_TIMEOUT",				(FPFI) GetIdleTimeout, 0, ""},
   {"IDLE_STATUS",				(FPFI) IdleEventStatus, 1, ".L"},
   {"",	(FPFI) EventInit, CALLONLOAD, ""},
   {"",	(FPFI) EventDone, CALLONUNLOAD, ""},
};

FoxTable _FoxTable = {
   (FoxTable *) 0, sizeof(myFoxInfo)/sizeof(FoxInfo), myFoxInfo
};
